import UnityEngine 

class t1d(MonoBehaviour): 
    public mat as Material
    public nx as int # total number of x-axis
    public ka as single # Deffusin constant of ativator
    public kb as single # Deffusin constant of inhibitor
    public r as single # self-regulation of activator
    public sa as single # rate activator produces inhibitor
    public sb as single # rate inhibitor reduces activator
    public dt as single # delta time
    public speed as int #
    
    count as int = 0 # 
    
    dx as single# Interval size in x directions
    ddx as single
    
    # conc of activator and inhibitor
    ui as (single,1)
    u  as (single,1) # activator
    vi as (single,1)
    v  as (single,1) # inhibitor
    
    def Start():
        Debug.Log("Started...")
        dx = 1.0/nx # Interval size in x directions
        ddx = dx
        ui = matrix(single, nx)
        u  = matrix(single, nx) # activator
        vi = matrix(single, nx)
        v  = matrix(single, nx) # inhibitor
        for i in range(nx):
            ui[i] = Random.value*10
            vi[i] = Random.value*10
        sliderlist = [ka, kb, r, sa, sb, dt]
        
    def Update(): 
        for i in range(speed) :
            step()
    
    def step(): 
        for i in range(1,nx-1):
            # activator
            u[i] = ui[i] + ka*dt*((ui[i+1] - 2*ui[i] + ui[i-1])/ddx) + r*dt*(ui[i]*ui[i]/vi[i]+1) - sa*dt*(ui[i])
            # inhibitor
            v[i] = vi[i] + kb*dt*((vi[i+1] - 2*vi[i] + vi[i-1])/ddx) - sb*dt*(vi[i]) + r*dt*(ui[i]*ui[i])
        u[0]=ui[1]
        u[nx-1]=ui[nx-2]
        v[0]=vi[1]
        v[nx-1]=vi[nx-2]
        ui=u
        vi=v
        count++
        
    def OnPostRender():
        if not mat: 
            Debug.LogError('Please Assign a material on the inspector')
            return 
        GL.PushMatrix() 
        mat.SetPass(0) 
        GL.LoadOrtho()
        # activator
        GL.Begin(GL.LINES)
        GL.Color(Color.magenta )
        for i in range(nx-1):
            GL.Vertex3(1.0*i/nx, ui[i]/10, 0)
            GL.Vertex3(1.0*(i+1)/nx, ui[i+1]/10, 0)
        GL.End();
        # inhibitor
        GL.Begin(GL.LINES)
        GL.Color(Color. cyan)
        for i in range(nx-1):
            GL.Vertex3(1.0*i/nx, vi[i]/10, 0)
            GL.Vertex3(1.0*(i+1)/nx, vi[i+1]/10, 0)
        GL.End();
        GL.PopMatrix();
    
    #
    # GUI
    #
    sliderlist = []
    slidername as (string)= ("ka", "kb", "r", "sa", "sb", "dt")
    final sliderinitvalues as (single) = (9.0f,9.0f,9.0f,9.0f,9.0f,9.0f)
    slidervalues = [x for x in sliderinitvalues]
    #
    tempid as int = -1
    tempvalue as single = 0
    #
    def OnGUI():
        # count
        GUI.Label(Rect(250, 20, 120, 20), (""+count))
        # buttons
        #  speed
        GUI.Label(Rect(10, 20, 120, 20), ("speed = "+speed))
        if GUI.RepeatButton(Rect(130, 20, 20, 20), "-"):
            speed--
            if speed==-1:
                speed++
        if GUI.RepeatButton(Rect(150, 20, 20, 20), "+"):
            speed++
        #  reset
        if GUI.Button(Rect(170, 20, 60, 20), "Reset"):
            for i in range(nx):
                ui[i] = Random.value*10
                vi[i] = Random.value*10
            count=0
        # sliders
        for i in range(len(sliderlist)):
            GUI.Label(Rect(10, 25*i+45, 120, 20), (slidername[i] as string + " = " + sliderlist[i]))
            slidervalues[i] = GUI.HorizontalSlider(Rect(130, 25*i+50, 100, 20), slidervalues[i], 0.0F, 18.0F)
            if not slidervalues[i]==sliderinitvalues[i]:
                if GUI.changed:
                    if tempid==-1:
                        tempid = i
                        tempvalue = sliderlist[i]
                    fa as single = slidervalues[tempid]
                    fb = sliderinitvalues[tempid]
                    if fa<fb:
                        sliderlist[tempid]= tempvalue/(fb-fa+1)
                    elif fa>fb :
                        sliderlist[tempid]= tempvalue*(fa-fb+1)
                    # update 
                    if tempid==0:
                        ka = sliderlist[0] 
                        if ka>kb:
                            ka=kb
                            sliderlist[0]=kb
                    elif tempid==1:
                        kb = sliderlist[1]
                        dtmax = ddx/( 2*kb)
                        if dt>dtmax:
                            dt=dtmax
                            sliderlist[5]=dtmax
                    elif tempid==2:
                        r = sliderlist[2]
                    elif tempid==3:
                        sa = sliderlist[3]
                    elif tempid==4:
                        sb = sliderlist[4]
                    elif tempid==5:
                        dt = sliderlist[5]
                        dtmax = ddx/( 2*kb)
                        if dt>dtmax:
                            dt=dtmax
                            sliderlist[5]=dtmax
                    elif tempid==6:
                        scale = sliderlist[6]
        if not Input.GetMouseButton(0):
            tempid = -1
            slidervalues =  [x for x in sliderinitvalues]